/******************************************************************************
 *  CVS version:
 *     $Id: error.h,v 1.1 2005/06/03 08:05:20 nickie Exp $
 ******************************************************************************
 *
 *  C header file : error.h
 *  Project       : Llama Compiler
 *  Version       : 1.0 alpha
 *  Description   : Simple error handler
 *
 *  Comments: (in Greek iso-8859-7)
 *  ---------
 *    .
 *       .
 *      .
 *    
 */


#ifndef __ERROR_H__
#define __ERROR_H__


/* ---------------------------------------------------------------------
   ---------------------------- Header files ---------------------------
   --------------------------------------------------------------------- */

#include <stdbool.h>


/* ---------------------------------------------------------------------
   ----------------------  , .. ----------------------
   --------------------------------------------------------------------- */

extern int  numErrors;
extern int  maxErrors;
extern bool flagWarnings;
extern int  numWarnings;
extern int  maxWarnings;


/* ---------------------------------------------------------------------
   ---------       ----------
   --------------------------------------------------------------------- */

#define internal(...) internal_raw(__FILE__, __LINE__, __VA_ARGS__)

void internal_raw (const char * fn, int lc, const char * fmt, ...);
void fatal        (const char * fmt, ...);
void error        (const char * fmt, ...);
void warning      (const char * fmt, ...);
void message      (const char * fmt, ...);


/* ---------------------------------------------------------------------
   --     ,     ...  --
   --------------------------------------------------------------------- */

#ifdef CHECK_ASSERT
#define ASSERT(P) do { \
      if (!(P)) \
         internal_raw(__FILE__, __LINE__, \
                      "assertion violation: %s\n", #P); \
   } while(0)
#else
#define ASSERT(P)
#endif


#endif
